import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { RouterModule } from '@angular/router';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { DynaformComponent } from '@modules/dynaform/dynaform.component';
import { DynafieldDirective } from '@modules/dynaform/directives/dynafield.directive';
import { DynaformService } from '@modules/dynaform/services/dynaform.service';
import { ModelMapperService } from '@modules/dynaform/services/model-mapper.service';

import * as formFieldComponents from '@modules/dynaform/components';
const ffcArr = Object.values(formFieldComponents); // Array of all the Form Field Components

import { DateInputsModule } from '@progress/kendo-angular-dateinputs';

@NgModule({
	imports: [
		CommonModule,
		FormsModule,
		ReactiveFormsModule,
		RouterModule.forChild([]),
		NgbModule,
		DateInputsModule
	],
	declarations: [
		DynaformComponent,
		DynafieldDirective,
		...ffcArr
	],
	entryComponents: ffcArr,
	providers: [
		DynaformService,
		ModelMapperService
	],
	exports: [
		FormsModule,
		ReactiveFormsModule,
		DynaformComponent,
		DynafieldDirective,
		ffcArr
	]
})
export class DynaformModule { }
