// TESTS: Metafirst form generation, with data grabbed from model using 'source'

const model = {
	fieldOne: 'fieldOne',
	fieldTwo: 'fieldTwo',
	fieldThree: 'I am fieldThree',
	double: '4',
	nest: {
		test: 'I am from nest.test',
		funcMap2: '3'
	},
	nestedGroup: {
		fieldA: 'nestedGroup.fieldA',
		fieldB: 'nestedGroup.fieldB',
		fieldC: 'nestedGroup.fieldC',
		anotherNestedGroup: {
			fieldE: 'nestedGroup.anotherNestedGroup.fieldE',
			fieldF: 'nestedGroup.anotherNestedGroup.fieldF',
			yetAnother: {
				fieldH: 'nestedGroup.anotherNestedGroup.yesAnother.fieldH',
				jay: 'I AM DEEPLY NESTED jay'
			}
		},
		z: 'THE END',
		testforSourcedNest: {
			soNestA: 'I am soNestA',
			soNestB: 'And this is soNestB',
			testC: 'CCC',
			e: {
				f: {
					g: {
						h: {
							i: 'DID YOU GO DEEPER?',
							deeperAgain: {
								j: 'DEEPEST Jay'
							}
						}
					}
				}
			}
		}
	},
	fucntionalSourcedNest: {
		aaa: '122',
		bbb: '455',
		ccc: '788'
	}
};

const meta = {
	a: { label: 'a should be fieldOne', source: 'fieldOne', class: 'medium-field' },
	b: { label: 'b should end with jay', source: 'nestedGroup.anotherNestedGroup.yetAnother.jay' },
	functionalMapping: {
		source: [
			'double',
			n => (parseFloat(n) / 2).toString(),
			n => (parseFloat(n) * 2).toString()
		]
	},
	nest: {
		label: 'Nested values',
		meta: {
			c: { label: 'c should be ...fieldC', source: '/nestedGroup.fieldC' },
			d: { label: 'd should be THE END', source: '/nestedGroup.z' },
			e: { label: 'e should be fieldThree', source: '/fieldThree', type: 'checkbutton' },
			test: { label: 'Test of default source' },
			funcMap2: {
				source: [
					n => (parseFloat(n) / 3).toString(),
					n => (parseFloat(n) * 3).toString()
				]
			}
		}
	},
	head: { type: 'heading', text: 'Default mappings (no \'source\')', before: 'fieldTwo' },
	fieldTwo: { type: 'textarea' },
	sourcedNest: {
		label: 'Nested values from source data tree',
		source: '/nestedGroup.testforSourcedNest',
		meta: {
			testA: { source: 'soNestA' },
			testB: { source: 'soNestB' },
			testC: { label: 'should be CCC' },
			deeper: {
				source: 'e.f.g.h',
				meta: {
					depthRetrivelWithinParentTree: { source: 'i' },
					deeperAgain: {
						meta: {
							veryDeep: { source: 'j', label: 'Should be DEEPEST Jay', class: 'medium-field' }
						}
					}
				}
			}
		}
	},
	fucntionalSourcedNest: {
		label: 'Nested values using function as datasource',
		source: [
			n => n,
			n => Object.entries(n)
				.map( ([key, val]) => [key, parseInt(<string>val) + 1] )
				.reduce( (acc, [key, val]) => { 
					acc[<string>key] = val;
					return acc;
				}, {})
		],
		meta: {
			aaa: {},
			bbb: {},
			ccc: {},
			ddd: {
				label: 'Nested functional mapping',
				source: [
					'aaa',
					n => (parseFloat(n) / 2).toString(),
					n => (parseFloat(n) * 2).toString()
				]
			}
		}
	},
	dfns: {
		label: 'Another functional mapping test, with a nested parent function',
		meta: {
			general: {
				source: [
					'/',
					n => n,
					n => ({ val: 'Zippy Zap', tal: 'Zero' })
				],
				meta: {
					val: { source: 'val' }
				}
			}
		}
	}
};

export { model, meta };
